libwin - Library
     Stainless windows support library

     Call  me  crazy,  but  I'm  getting  a  little  tired  of  walking 
     rectangles,  calculating slider sizes and positions,  and all  the 
     other stuff associated with GEM windows.  In my opinion,  all that 
     stuff should be done for me and all I should have to do is  redraw 
     the contents of a window.

     With  that  philosiphy  in  mind  I  have  created  a  library  of 
     functions  for use with Mark Williams C which take the hassle  out 
     of multiple overlapping windows program development. Here's how it 
     works:

     Basically,  stainless windows provide a level of distraction  from 
     the screen pixel co-ordinates that GEM AES works with. Windows are 
     described as a view of x by y cells upon a world of x by y  cells. 
     That  along  with the view offset gives me enough  information  to 
     position and size the sliders. You can define the cell size to any 
     x  by y pixels size you wish and change it at any  time.  If  your 
     window  contains text then your cell size might be 8 by  8  pixels 
     (the  size  of a character),  if it contains postage  stamps  then 
     perhaps  40  by 40 is more appropriate.  Other than  setting  some 
     basic  parameters and providing a redarw function,  you need  only 
     pass AES message buffers to the main control function and I do the 
     rest.  If  necessary I'll call your redraw function and  tell  you 
     which cells you need to redraw. What could be easier?

     I  hope this data and the accompanying demo program are enough  to 
     get you started, if not... sue me!!!

     If  you  are  suitably  impressed by the  results  of  using  this 
     toolkit,  perhaps you might consider a monatary donation,  note of 
     thanks or constructive criticism (I prefer the former). I am:

          Dave Steele
          168 Tartan Drive
          Nepean, Ontario, Canada
          K2J 3X3

     I  am also D.STEELE13 on GENIE but I don't see how that will  help 
     you to send money.

win_convert - Window function ( libwin )
     convert window cells AES box to/from screen pixels AES box
     #include <window.h>
     void win_convert ( win , type , frombox , tobox )
     win_struct_ptr win ;
     int type ;
     box_struct *frombox , *tobox ;

     win_convert  converts  an AES box of  window  specific  parameters 
     to/from an AES box of screen pixels. Windows are defined as arrays 
     of  cells,  each  of  which is x pixels wide  by  y  pixels  high. 
     win_convert can calculate the top right pixel of any cell (visible 
     or  not) and pixel width and height of an array of  cells  (useful 
     when  asked  to redraw cells) or can calculate which  cells  of  a 
     given  window  are  encompassed by an AES  box  of  screen  pixels 
     (useful to determine which cell the mouse is pointing at or  which 
     cells have been rubber-banded).

     win  is  a pointer to an initialized  win_struct.

     type  is a flag which specifies the conversion  type.  Values  for 
     type are defined in window.h as:
          TO_PIXELS convert from cells to pixels
          TO_CELLS  convert from pixels to cells

     frombox and tobox are pointers to box_struct.  tobox must point to 
     an  area  of  sufficient memory to hold  the  converted  box.  The 
     box_struct pointed to by frombox is not modified by win_convert.

win_init - Window function ( libwin )
     initialize a win_struct to default values
     #include <window.h>
     void win_init ( win )
     win_struct_ptr win ;

     win_init initializes a win_struct to default values. win_struct is 
     defined in window.h. The default values for the win_struct are:
          vdi       same as used by AES screen manager
          world     origin and size 0 , 0
          view      origin and size 0 , 0
          cell      cell size 1 pixel by 1 pixel
          constrain working area of AES window 0 (the screen)
          limit     no min or max window size defined
          home      0 , 0
          kind      0
          name      points to an empty string NUL terminated
          info      points to an empty string NUL terminated
          handle    -1
          redraw    NULL (no default redraw routine)
          oldsize   none of your business
          user      NULL (this is yours to do with as you please)
          next      also none of your business

     win is a pointer to the win_struct to be initialized.  As such you 
     must ensure that it points to an area of sufficient memory.

win_open - Window function ( libwin )
     display or top a window
     #include <window.h>
     int win_open ( win , frombox )
     win_struct_ptr win ;
     box_struct *frombox ;

     win_open creates and opens an AES window. If the window is already 
     open then it moves it to the top.  It's a pretty good idea to call 
     win_setredraw before this as this call will almost certainly cause 
     the AES to request a window redraw,  which in turn will cause  the 
     user defined redraw routine to be called when the event is handled 
     by window_msg.

     win is a pointer to an initialized win_struct.

     frombox is a pointer to an option AES box structure from which the
     window will be grown. If NULL is passed the window will grow  from
     the center of it's grown location.

     win_open   returns   a  non-zero  value  if  the   window   opened 
     successfully. 

win_close - Window function ( libwin )
     erase a displayed window
     #include <window.h>
     void win_close ( win , tobox )
     win_struct_ptr win ;
     win_struct *tobox ;

     win_close closes and deletes an AES window.  A subsequent call  to 
     win_open  will re-open the window exactly as it was before it  was 
     closed (it even remembers if it was fulled and where it was before 
     it was fulled).

     win is a pointer to an initialized win_struct.

     tobox is a pointer  to an option AES box  structure into which the
     window will shrink. If  NULL is passed  the window will  shrink to
     it's center location.

win_cellshift - Window function ( libwin )
     shift any portion of a window in any direction
     #include <window.h>
     void win_cellshift ( win , cells , dx , dy )
     win_struct_ptr win ;
     box_struct *cells ;
     int dx , dy ;

     win_cellshift  shifts  and/or redraws any portion  of  the  window 
     contents. It could be used to shift up the top half of a window in 
     order to insert something in the middle.  If dx and dy are both  0 
     then  a redraw of the cell area is forced.  This  is  useful,  for 
     instance,  when creating a text-based window to redraw cells  just 
     behind the cursor as thay are added to the text. Don't worry about 
     checking if the cells are visible (in the current view area), I'll 
     do that for you.

     win is a pointer to the window's initialized win_struct.

     cells is a pointer to a box_struct which defines the cell area  to 
     be shifted/redrawn.

     dx and dy are the cell offsets by which the window area should  be 
     shifted.

win_shift - Window function ( libwin )
     shift the visible portion of a window in any direction
     #include <window.h>
     void win_shift ( win , dx , dy )
     win_struct_ptr win ;
     int dx , dy ;

     win_shift  shifts  or  redraws the entire  visible  portion  of  a 
     window. 

     win is a pointer to the window's initialized win_struct.

     dx and dy are the cell offsets by which the visible portion of the 
     window should be shifted.  This function may call the user defined 
     redraw  routine  for the window in order to redraw  newly  visible 
     areas.  If  dx  and  dy are both 0 then the  user  defined  redraw 
     routine will be called to redraw the entire window.

win_setkind - Window function ( libwin )
     set or change the AES attributes of a window
     #include <window.h>
     void win_setkind ( win , kind )
     win_struct_ptr win ;
     int kind ;

     win_setkind  set  the attributes associated with  an  AES  window. 
     Rather than specifying them when the window is created,  they  can 
     be  changed  at  any time with this  call.  Current  settings  are 
     contained  in  win->flags allowing individual bits to  be  set  or 
     masked. The default condition after win_init is all flags cleared.

     win is a pointer to the window's initialized win_struct.

     kind  indicates  the  desired window elements  (see  AES  function 
     wind_create for details).

win_setnameinfo - Window function ( libwin )
     set or change the name and/or info strings of a window
     #include <window.h>
     void win_setnameinfo ( win , name , info )
     win_struct_ptr win ;
     char *name , *info ;

     win_setnameinfo  initializes  or changes the name and  info  lines 
     which  may  appear at the top of the window (depending  on  kind). 
     Pointers  to  the current name and info strings are  contained  in 
     win->name  and  win->info  allowing either string  to  be  changed 
     independantly of the other.  The default condition after  win_init 
     is name = "\0" , info = "\0".

     win is a pointer to the window's initialized win_struct.

     name and info are pointers to null terminated strings.

win_setconstrain - Window function ( libwin )
     set or change the AES box within which a window is constrained
     #include <window.h>
     void win_setconstrain ( win , x , y , w , h )
     win_struct_ptr win ;
     int x , y , w , h ;

     win_setconstrain causes a window (including future actions) to  be 
     constrained  within any area on the screen.  This can be  used  to 
     keep a window from overlapping the edge of the screen or to  allow 
     a  window  to be constrained within the visible  area  of  another 
     window. The default condition after win_init is constrained to the 
     working area of the screen.

     win is a pointer to the window's initialized win_struct.

     x , y , w , h are integers describing the top left screen pixel of 
     the constraining box and the width and height of the box in screen 
     pixels.

win_sethome - Window function ( libwin )
     set or change the upper-left pixel position of a window
     #include <window.h>
     void win_sethome ( win , x , y )
     win_struct_ptr win ;
     int x , y ;

     win_sethome  changes the x ,  y screen pixel location of  the  top 
     left  position  of the working area of a  window.  Of  course  the 
     position   is   constrained  within  the  rectangle   defined   by 
     win_setconstrain. The default condition after win_init is 0 , 0.

     win is a pointer to the window's initialized win_struct.

     x , y are integer co-ordinates of the top left position.

win_setlimit - Window function ( libwin )
     set or change the min/max number of cells a window can display
     #include <window.h>
     void win_setlimit ( win , xmin , ymin , xmax , ymax )
     win_struct_ptr win ;
     int xmin , ymin , xmax , ymax ;

     win_setlimit  allows  you to set the minimum and  maximum  visible 
     size of a window in cells.  A tet window for instance,  consisting 
     of  cells each of which is the size of one character,  can be  set 
     such  that the minimum number of rows and columns visible is 40  X 
     15,  and the maximum is 80 x 25.  Of course this assumes that 80 x 
     25  characters  plus  border  will  fit  within  the  constraining 
     rectangle.  Specifying a minimum or maximum of 0 means  unlimited. 
     The default condition after win_init is unlimited.

     win is a pointer to the window's initialized win_struct.

     xmin , ymin , xmax , ymax are the cell limits of the window.

win_setworld - Window function ( libwin )
     set or change the number of cells upon which the window views
     #include <window.h>
     void win_setworld ( win , x , y , w , h )
     win_struct_ptr win ;
     int x , y , w , h ;

     win_setworld is used to describe the size of the world upon  which 
     a window is but a view.  A text document may be 5076 lines of  132 
     columns even though the window only presents a view of 25 rows  of 
     80 columns. Proving the world size along with view size allows the 
     window  sliders  to be automatically  sized  and  positioned.  The 
     default condition after win_init is 0 , 0 , 0 , 0.

     win is a pointer to the window's initialized win_struct.

     x , y , w , h provide the home position and size of the world (see 
     win_normal for more on the home position).

win_setview - Window function ( libwin )
     set or change the number cells in the current window view
     #include <window.h>
     void win_setview ( win , x , y , w , h )
     win_struct_ptr win ;
     int x , y , w , h ;

     win_setview  sets the size of the window view in cells  and  which 
     cell should appear in the top right location.  The position of the 
     window  view is constrained within the world as  described  above. 
     The  size  is adjusted if required to meet the parameters  set  by 
     win_setlimit.  The default condition fter win_init is 0 ,  0 , 0 , 
     0.

     win is a pointer to the window's initialized win_struct.

     x , y , w , h describe the home cell and size of the view.

win_setcellvdi - Window function ( libwin )
     set or change the size of one cell and/or the vdi handle of a window
     #include <window.h>
     void win_setcellvdi ( win , x , y , vdi )
     win_struct_ptr win ;
     int x , y , vdi ;

     win_setcellvdi  sets  the  size of each window cell  and  the  vdi 
     handle  which  should  used to redraw it.  Actually  you  have  to 
     provide  the redraw routine but when it is called the window  will 
     already be clipped using the appropriate vdi handle. Cell size and 
     VDI  handle are also closely linked when the window contains  text 
     as one window/VDI may be set for 7-point swiss and another for 10-
     point  times-roman.   The  default  condition  after  win_init  is 
     cellsize = 1 , 1 VDI handle is same as used by AES.

     win is a pointer to the window's initialized win_struct.

     x , y are the size of each cell within a window.

     vdi is the vdi handle to be used for clipping and redraw.

win_setredraw - Window function ( libwin )
     set or change the user supplied function to redraw a window
     #include <window.h>
     void win_setredraw ( win , redraw )
     win_struct_ptr win ;
     void ( *redraw ) ( ) ;

     Pointers  to  functions...  what a concept!!!  This is  where  you 
     provide  a function which will be called whenever a portion  of  a 
     window needs to be redrawn (a different function for each window). 

     The function should be declared something like this:

          void fn_name ( win , cellrect , pixrect )
          win_struct_ptr win ;
          box_struct *cellrect , *pixrect ;

     The  default condition after win_init is NULL which  means  window 
     contents will not be redrawn.

     win is a pointer to the window's initialized win_struct.

     cellrect is an AES rectangle which indicates which cells to redraw 
     (use  win_convert  if you need to find the pixel position  of  the 
     cells).

     pixrect is an AES rectangle which indicates the currently  clipped 
     area  (not the same as the converted cellrect).  It's really  only 
     supplied  for  use with AES objc_draw when using the  default  VDI 
     handle.

     redraw  is the function that you are supplying (fn_name  in  above 
     example).

win_setprehook  - Window function ( libwin )
     set or change the user supplied control hook functions
     #include <window.h>
     void win_setprehook ( win , prehook )
     win_struct_ptr win ;
     int ( *prehook ) ( ) ;

     This function allow you to install a hook in the processing of the
     window_msg function. After window_msg has determined which  window
     record  is  associated  with  an  action,  it checks if a  prehook
     routine has been installed for that window. If one has then  it is
     called with the window record and the AES  message pointers passed
     as parameters. You can handle the message in any way  you see  fit
     (use the full button to change font sizes). Your  function  should
     return non-zero to continue standard processing or zero to bypass.

     The function should be declared something like this:

          void fn_name ( win , msg )
          win_struct_ptr win ;
          int msg[8] ;

     The  default condition after win_init is NULL which  means  window 
     controls will behave as expected.

     win is a pointer to the window's initialized win_struct.

     msg is the AES message buffer  which contains  the details  of the
     user interaction (i.e. WM_FULLED).

     prehook is the function that you are supplying (fn_name  in  above
     example).

win_setuser - Window function ( libwin )
     set the user pointer
     #include <window.h>
     void win_setuser ( win , user )
     win_struct_ptr win ;
     char *user ;

     The user pointer is exactly that... a user pointer. You can use it
     for anything you want.  I usually use it to associate  a structure
     or OBJECT pointer to a given window.

     win is a pointer to the window's initialized win_struct  (actually 
     it doesn't have to be initialized because win_init doesn't clobber
     the user pointer.

     user is a pointer to what ever you feel like pointing to.
     
win_getrec - Window function ( libwin )
     get the win_struct of a particular AES window
     #include <window.h>
     win_struct_ptr win_getrec ( handle )
     int handle ;

     win_getrec  is useful in those rare situations where you know  the 
     AES handle of a window and you need to know which win_struct it is 
     associated with.

     win is a pointer to the window's initialized win_struct.

     handle is the AES handle of a window.

     win_getrec  returns  a pointer to the win_struct  associated  with 
     handle.

win_normal - Window function ( libwin )
     normalize the window such that the world home position is 0 , 0
     #include <window.h>
     void win_normal ( win )
     win_struct_ptr win ;

     win_normal normalizes the world and view associated with a  window 
     such that the world home becomes 0 ,  0.  When you need to add  or 
     remove information at the top of a window, this is real handy.

     win is a pointer to the window's initialized win_struct.

window_msg - Window function ( libwin )
     perform all necessary actions to update a window
     #include <window.h>
     int window_msg ( msg )
     int msg[8] ;

     window_msg does everything associated with window control. All you 
     need  to do is pass it an AES message buffer (see  evnt_messag  or 
     evnt_multi)  and  it does the rest.  The redraw routine  that  you 
     supplied  will be called as often as needed to update the  display 
     and you don't even need to know it's happening.

     msg is an AES message buffer.

     window_msg returns 0 if the message buffer was not associated with 
     any  windows  created with win_open (could have  been  an  AC_OPEN 
     message or something) or non-0 if it was.

